import logging
import os

from flask import Flask

from . import consul, storage, rabbit


def setup_logging():
    logging.basicConfig(level=logging.INFO)
    logging.getLogger("pika").setLevel(logging.WARNING)
    logging.getLogger("sqlite3").setLevel(logging.WARNING)


def create_app():
    app = Flask(__name__, instance_relative_config=True)

    consul.register(os.environ["SVC_TYPE"])
    storage.init_db(app)
    app.teardown_appcontext(storage.close_db)
    rabbit.connect()

    return app
