import logging
import threading

import pika


channel = None


def __get_connection__():
    return pika.BlockingConnection(pika.ConnectionParameters(host="rabbitmq"))


def connect():
    global channel
    channel = __get_connection__().channel()


def declare_exchange(exchange):
    channel.exchange_declare(exchange=exchange, exchange_type="direct")


def __declare_queue__(name):
    result = channel.queue_declare(queue=name, exclusive=True)
    return result.method.queue


def publish(exchange, key, body):
    channel.basic_publish(exchange=exchange, routing_key=key, body=body)


def subscribe(exchange, key=None, callback=lambda ch, method, properties, body: logging.error(body)):
    declare_exchange(exchange)
    queue_name = __declare_queue__("")
    channel.queue_bind(exchange=exchange, queue=queue_name, routing_key=key)
    channel.basic_consume(queue=queue_name, on_message_callback=callback, auto_ack=True)

    logging.info("Connected to RabbitMQ")

    global thread
    thread = threading.Thread(target=start_receiving,
                              args=(channel,),
                              daemon=True)
    thread.start()
    # connection.close()


def start_receiving(channel):
    channel.start_consuming()


def disconnect():
    global channel
    channel = None
